//Sample using LiquidCrystal library
#include <LiquidCrystal.h>
#include <Time.h> 
 
/*******************************************************
 
This program will test the LCD panel and the buttons
Mark Bramwell, July 2010
 
********************************************************/
 
// select the pins used on the LCD panel
LiquidCrystal lcd(8, 9, 4, 5, 6, 7);
 
char* MenuPunkt0[2] = {"Settings", "Start work"};
char* MenuPunkt1[7] = {"Time", "Sound", "Set Unit 1", "Set Unit 2", "Set Unit 3", "Set Unit 4", "Return"};
char* MenuPunkt2[3] = {"Hours", "Minuts", "Return"};
char* MenuPunkt3[3] = {"Sound ON", "Sound OFF", "Return"};
char* MenuPunkt4[4] = {"None","Pompa", "Lamp", "Return"};
char* MenuPunkt5[3] = {"Work by shed.", "Work by humi.", "Return"};
char* MenuPunkt6[3] = {"Shedule", "Duration", "Return"};
char* MenuPunkt7[5] = {"Every 1 day", "Every 2 day", "Every 7 day", "Every month", "Return"};
char* MenuPunkt8[4] = {"5 sec.", "10 sec.", "15 sec.", "Return"};
char* MenuPunkt9[3] = {"Time ON", "Time OFF", "Return"};
int maxPunktMemu[10] = {2,7,3,3,4,3,3,5,4,3};
int maxkolpunkt=0;
boolean IsConfig = true; // Мы в конфигурации?
boolean isDebug = true;
boolean isSound = true;
int posMenu = 0; //выбранная Позиция в меню.
int startPos=0; //Стартовая позиция при прорисовке меню
int nUnit[4] = {0,0,0,0}; //Что находится на первом устройстве 0-ничего, 1-Помпа, 2- Лампа
int nUnitworkBy[4] = {0,0,0,0}; //режим работы 0 - по расписанию, 1 - по влажности
int nUnitShed[4] = {1,1,1,1}; //Расписание 1= 1 раз в день 2= 1 раз в 2 дня, 7 = 1 раз в 7 дней, 30 = 1 раз в месяц 
int nUnitDur[4] = {1,1,1,1}; //Длительность полиыв 1- 5 сек, 2- 10 сек, 3- 15 сек.

int nHumidity[4] = {8000,8000,8000,8000}; //Показатель влажности пороговый

int nMinutON=0; //минуты включения света
int nHourON=7; //время включения света
int nMinutOFF=0; //минуты включения света
int nHourOFF=22; //время включения света
String currentMenu = "0";
int nUnitNumber;

// define some values used by the panel and buttons
int lcd_key     = 0;
int adc_key_in  = 0;
#define btnRIGHT  0
#define btnUP     1
#define btnDOWN   2
#define btnLEFT   3
#define btnSELECT 4
#define btnNONE   5

////////////////////////////////
int getFreeRam() {
  extern int __heap_start, *__brkval;
  int v;
  return (int) &v - (__brkval == 0 ? (int) &__heap_start : (int) __brkval);
}
 
extern unsigned int __heap_start;
extern void *__brkval;
 
/*
* The free list structure as maintained by the
* avr-libc memory allocation routines.
*/
struct __freelist {
  size_t sz;
  struct __freelist *nx;
};
 
/* The head of the free list structure */
extern struct __freelist *__flp;
 
/* Calculates the size of the free list */
int freeListSize() {
  struct __freelist* current;
  int total = 0;
 
  for (current = __flp; current; current = current->nx) {
	total += 2; /* Add two bytes for the memory block's header  */
	total += (int) current->sz;
  }
 
  return total;
}
 
int freeMemory() {
  int free_memory;
 
  if ((int)__brkval == 0) {
	free_memory = ((int)&free_memory) - ((int)&__heap_start);
  } else {
	free_memory = ((int)&free_memory) - ((int)__brkval);
	free_memory += freeListSize();
  }
  return free_memory;
}
////////////////////////////////
 
// read the buttons
int read_LCD_buttons()
{
 adc_key_in = analogRead(0);      // read the value from the sensor 
 // my buttons when read are centered at these valies: 0, 144, 329, 504, 741
 // we add approx 50 to those values and check to see if we are close
 if (adc_key_in > 1000) return btnNONE; // We make this the 1st option for speed reasons since it will be the most likely result
 if (adc_key_in < 50)   return btnRIGHT;  
 if (adc_key_in < 195)  return btnUP; 
 if (adc_key_in < 380)  return btnDOWN; 
 if (adc_key_in < 555)  return btnLEFT; 
 if (adc_key_in < 790)  return btnSELECT;   
 return btnNONE;  // when all others fail, return this...
}
 
void Menu(String levelMenu, int selectPos) {
//  if (isDebug) {  Serial.print("levelMenu:"); Serial.println(levelMenu);}
if (levelMenu=="0") {
      // statements
      maxkolpunkt=0;//Указатель на индек в массиве максимальных значений меню
      for (int i=0; i <= 1; i++)
      {
        lcd.setCursor(0,i);
        if (selectPos == i) {lcd.print("\x7E"+String( MenuPunkt0[i]));} else {lcd.print(" "+String(MenuPunkt0[i]));}
      }
} else if (levelMenu=="00") { // меню settings
    maxkolpunkt=1; //Указатель на индек в массиве максимальных значений меню
    if (isDebug) {  Serial.print("startPos:"); Serial.println(startPos);}
    if (isDebug) {  Serial.print("selectPos:"); Serial.println(selectPos);}
    for (int i=0; i <= 1; i++)      
      {
        lcd.setCursor(0,i); 
        if (selectPos-startPos == i) {lcd.print("\x7E"+String( MenuPunkt1[i+startPos]));} else {lcd.print(" "+String(MenuPunkt1[i+startPos]));}
      }
} else if (levelMenu=="000") { // меню Time
    maxkolpunkt=2; //Указатель на индек в массиве максимальных значений меню
    for (int i=0; i <= 1; i++)      
      {
        lcd.setCursor(0,i); 
        if (selectPos-startPos == i) {
          if (MenuPunkt2[i+startPos]=="Hours") {lcd.print("\x7E"+String( MenuPunkt2[i+startPos])+": "+hour());}
          if (MenuPunkt2[i+startPos]=="Minuts") {lcd.print("\x7E"+String( MenuPunkt2[i+startPos])+": "+minute());}
          if (MenuPunkt2[i+startPos]=="Return") {lcd.print("\x7E"+String( MenuPunkt2[i+startPos]));}
      } else {
        if (MenuPunkt2[i+startPos]=="Hours") {lcd.print(" "+String(MenuPunkt2[i+startPos])+": "+hour());}
        if (MenuPunkt2[i+startPos]=="Minuts") {lcd.print(" "+String(MenuPunkt2[i+startPos])+": "+minute());}
        if (MenuPunkt2[i+startPos]=="Return") {lcd.print("\x7E"+String( MenuPunkt2[i+startPos]));}
      }
      }
}else if (levelMenu=="0000") { // меню Часы
    maxkolpunkt=2; //Указатель на индек в массиве максимальных значений меню
       lcd.setCursor(0,0);
       lcd.print("Use UP/DOWN/Enter");
       lcd.setCursor(0,1);
       lcd.print(String(hour()));
} else if (levelMenu=="0001") { // меню Минуты
    maxkolpunkt=2; //Указатель на индек в массиве максимальных значений меню
       lcd.setCursor(0,0);
       lcd.print("Use UP/DOWN/Enter");
       lcd.setCursor(0,1);
       lcd.print(String(minute()));
} else if (levelMenu=="001") { // меню sound
    maxkolpunkt=3; //Указатель на индек в массиве максимальных значений меню
    for (int i=0; i <= 1; i++)      
      {
        lcd.setCursor(0,i); 
           if (selectPos-startPos == i) {lcd.print("\x7E"+String( MenuPunkt3[i+startPos]));} else {lcd.print(" "+String(MenuPunkt3[i+startPos]));}
           if (isSound&&(MenuPunkt3[i+startPos]=="Sound ON")) {lcd.print("  *");}
           if (!isSound&&(MenuPunkt3[i+startPos]=="Sound OFF")) {lcd.print(" *");}
      }
} else if ((levelMenu=="002")||(levelMenu=="003")||(levelMenu=="004")||(levelMenu=="005")) { // меню sound
    maxkolpunkt=4; //Указатель на индек в массиве максимальных значений меню
    for (int i=0; i <= 1; i++)      
      {
        lcd.setCursor(0,i); 
           if (selectPos-startPos == i) {lcd.print("\x7E"+String( MenuPunkt4[i+startPos]));} else {lcd.print(" "+String(MenuPunkt4[i+startPos]));}
           if ((nUnit[nUnitNumber]==1)&&(MenuPunkt4[i+startPos]=="Pompa")) {lcd.print(" *");}
           if ((nUnit[nUnitNumber]==2)&&(MenuPunkt4[i+startPos]=="Lamp")) {lcd.print("  *");}
           if ((nUnit[nUnitNumber]==0)&&(MenuPunkt4[i+startPos]=="None")) {lcd.print("  *");}
      }
} else if ((levelMenu=="0021")||(levelMenu=="0031")||(levelMenu=="0041")||(levelMenu=="0051")) { // меню режима работы по расписанию или по влажности
    maxkolpunkt=5; //Указатель на индек в массиве максимальных значений меню
    for (int i=0; i <= 1; i++)      
      {
        lcd.setCursor(0,i); 
           if (selectPos-startPos == i) {lcd.print("\x7E"+String( MenuPunkt5[i+startPos]));} else {lcd.print(" "+String(MenuPunkt5[i+startPos]));}
           if ((nUnitworkBy[nUnitNumber]==0)&&(MenuPunkt5[i+startPos]=="Work by shed.")) {lcd.print(" *");}
           if ((nUnitworkBy[nUnitNumber]==1)&&(MenuPunkt5[i+startPos]=="Work by humi.")) {lcd.print(" *");}
         }
} else if ((levelMenu=="00210")||(levelMenu=="00310")||(levelMenu=="00410")||(levelMenu=="00510")) { // меню режима работы по расписанию или по влажности
    maxkolpunkt=6; //Указатель на индек в массиве максимальных значений меню
    for (int i=0; i <= 1; i++)      
      {
        lcd.setCursor(0,i); 
           if (selectPos-startPos == i) {lcd.print("\x7E"+String( MenuPunkt6[i+startPos]));} else {lcd.print(" "+String(MenuPunkt6[i+startPos]));}
         }
} else if ((levelMenu=="002100")||(levelMenu=="003100")||(levelMenu=="004100")||(levelMenu=="005100")) { // меню режима работы по расписанию или по влажности
    maxkolpunkt=7; //Указатель на индек в массиве максимальных значений меню
    for (int i=0; i <= 1; i++)      
      {
        lcd.setCursor(0,i); 
           if (selectPos-startPos == i) {lcd.print("\x7E"+String( MenuPunkt7[i+startPos]));} else {lcd.print(" "+String(MenuPunkt7[i+startPos]));}
           if ((nUnitShed[nUnitNumber]==1)&&(MenuPunkt7[i+startPos]=="Every 1 day")) {lcd.print(" *");}
           if ((nUnitShed[nUnitNumber]==2)&&(MenuPunkt7[i+startPos]=="Every 2 day")) {lcd.print(" *");}
           if ((nUnitShed[nUnitNumber]==7)&&(MenuPunkt7[i+startPos]=="Every 7 day")) {lcd.print(" *");}
           if ((nUnitShed[nUnitNumber]==30)&&(MenuPunkt7[i+startPos]=="Every month")) {lcd.print(" *");}
         }
} else if ((levelMenu=="002101")||(levelMenu=="003101")||(levelMenu=="004101")||(levelMenu=="005101")) { // меню длительность полива
    maxkolpunkt=8; //Указатель на индек в массиве максимальных значений меню
    for (int i=0; i <= 1; i++)      
      {
        lcd.setCursor(0,i); 
           if (selectPos-startPos == i) {lcd.print("\x7E"+String( MenuPunkt8[i+startPos]));} else {lcd.print(" "+String(MenuPunkt8[i+startPos]));}
           if ((nUnitDur[nUnitNumber]==1)&&(MenuPunkt8[i+startPos]=="5 sec.")) {lcd.print("  *");}
           if ((nUnitDur[nUnitNumber]==2)&&(MenuPunkt8[i+startPos]=="10 sec.")) {lcd.print(" *");}
           if ((nUnitDur[nUnitNumber]==3)&&(MenuPunkt8[i+startPos]=="15 sec.")) {lcd.print(" *");}
           }
} else if ((levelMenu=="00211")||(levelMenu=="00311")||(levelMenu=="00411")||(levelMenu=="00511")) { // меню Влажность
    maxkolpunkt=2; //Указатель на индек в массиве максимальных значений меню
       lcd.setCursor(0,0);
       lcd.print("Use UP/DOWN/Enter");
       lcd.setCursor(0,1);
       lcd.print(String(nHumidity[nUnitNumber]));
} else if (levelMenu=="0022") { // меню режима работы по расписанию или по влажности
    maxkolpunkt=9; //Указатель на индек в массиве максимальных значений меню
    for (int i=0; i <= 1; i++)      
      {
        lcd.setCursor(0,i); 
           if (selectPos-startPos == i) {lcd.print("\x7E"+String( MenuPunkt9[i+startPos]));} else {lcd.print(" "+String(MenuPunkt9[i+startPos]));}
         }
} else if ((levelMenu=="00220")||(levelMenu=="00221"))  { // меню часы минуты
    for (int i=0; i <= 1; i++)      
      {
        lcd.setCursor(0,i); 
           if (selectPos-startPos == i) {lcd.print("\x7E"+String( MenuPunkt2[i+startPos]));} else {lcd.print(" "+String(MenuPunkt2[i+startPos]));}
         }
} else if (levelMenu=="002200") { // меню часы минуты
    maxkolpunkt=2; //Указатель на индек в массиве максимальных значений меню
       lcd.setCursor(0,0);
       lcd.print("Use UP/DOWN/Enter");
       lcd.setCursor(0,1);
       lcd.print(String(nHourON));
} else if (levelMenu=="002201") { // меню минуты
    maxkolpunkt=2; //Указатель на индек в массиве максимальных значений меню
       lcd.setCursor(0,0);
       lcd.print("Use UP/DOWN/Enter");
       lcd.setCursor(0,1);
       lcd.print(String(nMinutON));
} else if (levelMenu=="002210") { // меню часы минуты
    maxkolpunkt=2; //Указатель на индек в массиве максимальных значений меню
       lcd.setCursor(0,0);
       lcd.print("Use UP/DOWN/Enter");
       lcd.setCursor(0,1);
       lcd.print(String(nHourOFF));
} else if (levelMenu=="002211") { // меню минуты
    maxkolpunkt=2; //Указатель на индек в массиве максимальных значений меню
       lcd.setCursor(0,0);
       lcd.print("Use UP/DOWN/Enter");
       lcd.setCursor(0,1);
       lcd.print(String(nMinutOFF));
}
}

void SetupConfig()
{
//FirstStart = false;
 Menu(currentMenu, posMenu);
 
}

void  MenuMinus()
{
 currentMenu=currentMenu.substring(0,currentMenu.length()-1);
posMenu=0;
  startPos=0;
}

void  PushKey (int lcd_key) 
{
    if (isDebug) {  Serial.print("currentMenu:"); Serial.println(currentMenu);}
 switch (lcd_key)               // Выбираем действия по нажатой клавише.
 {
   case btnRIGHT: //Нажата кнопка в право
     {
      lcd.clear();
      if (isDebug) {  Serial.print("posMenu:"); Serial.println(posMenu);}
      if ((currentMenu=="0000")||(currentMenu=="0001")) { // Возврат в предыдущее меню
         MenuMinus();
         delay(300);
    } else { //Иначе переход в следующее меню
      currentMenu=currentMenu+String(posMenu); 
      
           if (currentMenu=="002") {
             //проверяем каким устройством управляем
             nUnitNumber=0; //Устройство 1
           } else  if (currentMenu=="003") {
             //проверяем каким устройством управляем
             nUnitNumber=1; //Устройство 2
           }else  if (currentMenu=="004") {
             //проверяем каким устройством управляем
             nUnitNumber=2; //Устройство 3
           } else  if (currentMenu=="005") {
             //проверяем каким устройством управляем
             nUnitNumber=3; //Устройство 4
           }
      if (isDebug) {Serial.print("Plus menu"); Serial.println(posMenu);}
      delay(300);
     if ((currentMenu=="0031004")||(currentMenu=="0041004")||(currentMenu=="0051004")||(currentMenu=="003110")||(currentMenu=="004110")) { //||(currentMenu=="005110")
         MenuMinus();  MenuMinus();}
      if ((currentMenu=="0002")||(currentMenu=="0012")||(currentMenu=="006")||(currentMenu=="0023")||(currentMenu=="00212")||(currentMenu=="002102")||(currentMenu=="0021004")||(currentMenu=="0021013")
      ||(currentMenu=="002110")||(currentMenu=="00222")||(currentMenu=="002202")||(currentMenu=="002212")||(currentMenu=="0022000")||(currentMenu=="0022010")||(currentMenu=="0022100")||(currentMenu=="0022110")
      ||(currentMenu=="0033")||(currentMenu=="0043")||(currentMenu=="0053")||(currentMenu=="00312")||(currentMenu=="00412")||(currentMenu=="00512")||(currentMenu=="003102")||(currentMenu=="004102")
      ||(currentMenu=="005102")) {//проверка на return 
      //||
        MenuMinus();  MenuMinus();
      } 
        else if (currentMenu=="0010") { // Звук вкючен
                 isSound=true;
                 MenuMinus();
      } else if (currentMenu=="0011") { // Звук вывкючен
       isSound=false;
       MenuMinus();
      }else if ((currentMenu=="0020")||(currentMenu=="0030")||(currentMenu=="0040")||(currentMenu=="0050")) { // Устройство 1 отключено
       nUnit[nUnitNumber]=0;
       MenuMinus();
      } else if ((currentMenu=="0021")||(currentMenu=="0031")||(currentMenu=="0041")||(currentMenu=="0051")) { // Устройство 1 Помпа
       nUnit[nUnitNumber]=1;
      } else if ((currentMenu=="0022")||(currentMenu=="0032")||(currentMenu=="0042")||(currentMenu=="0052")) { // Устройство 1 Лампа
       nUnit[nUnitNumber]=2;
      }  else if ((currentMenu=="00210")||(currentMenu=="00310")||(currentMenu=="00410")||(currentMenu=="00510")) { // Устройство 1 работает по расписанию
       nUnitworkBy[nUnitNumber]=0;
      } else if ((currentMenu=="00211")||(currentMenu=="00311")||(currentMenu=="00411")||(currentMenu=="00511")) { // Устройство 1 работает по влажности
       nUnitworkBy[nUnitNumber]=1;
      }else if ((currentMenu=="0021000")||(currentMenu=="0031000")||(currentMenu=="0041000")||(currentMenu=="0051000")) { // Устройство 1 работа по расписанию 1 раз в день
       nUnitShed[nUnitNumber]=1;
       MenuMinus();
      } else if ((currentMenu=="0021001")||(currentMenu=="0031001")||(currentMenu=="0041001")||(currentMenu=="0051001")) { // Устройство 1 работа по расписанию 1 раз в день
       nUnitShed[nUnitNumber]=2;
       MenuMinus();
      } else if ((currentMenu=="0021002")||(currentMenu=="0031002")||(currentMenu=="0041002")||(currentMenu=="0051002")) { // Устройство 1 работа по расписанию 1 раз в день
       nUnitShed[nUnitNumber]=7;
       MenuMinus();
      } else if ((currentMenu=="0021003")||(currentMenu=="0031003")||(currentMenu=="0041003")||(currentMenu=="0051003")) { // Устройство 1 работа по расписанию 1 раз в день
       nUnitShed[nUnitNumber]=30;
       MenuMinus();
      } else if ((currentMenu=="0021010")||(currentMenu=="0031010")||(currentMenu=="0041010")||(currentMenu=="0051010")) { // Устройство длительность полива 
       nUnitDur[nUnitNumber]=1;
       MenuMinus();
      } else if ((currentMenu=="0021011")) { // Устройство длительность полива ||(currentMenu=="0031011")||(currentMenu=="0041011")||(currentMenu=="0051011")
       nUnitDur[nUnitNumber]=2;
       MenuMinus();
      } else if ((currentMenu=="0021012")) { // Устройство длительность полива ||(currentMenu=="0031012")||(currentMenu=="0041012")||(currentMenu=="0051012")
       nUnitDur[nUnitNumber]=2;
       MenuMinus();
      }
    }
    
      startPos=0;
      posMenu=0;
      
  //   lcd.print("RIGHT ");
     break;
     }
   case btnLEFT:
     {
     lcd.print("LEFT   ");
     break;
     }
   case btnUP:
     {
        if (currentMenu=="0000") {
         adjustTime(60*60);
         delay(200);
       } else if (currentMenu=="0001")
       { adjustTime(60);
         delay(200);
       } else if ((currentMenu=="00211")||(currentMenu=="00311")||(currentMenu=="00411")||(currentMenu=="00511")){ 
                         nHumidity[nUnitNumber]=nHumidity[nUnitNumber]+10;
                         delay(200);
       } else if (currentMenu=="002200"){ 
                         nHourON++;
                         if (nHourON==24) {nHourON=0;}
                         delay(200);
       } else if (currentMenu=="002201"){ 
                         nMinutON++;
                         if (nMinutON==60) {nMinutON=0;}
                         delay(200);
       } else if (currentMenu=="002210"){ 
                         nHourOFF++;
                         if (nHourOFF==24) {nHourOFF=0;}
                         delay(200);
       } else if (currentMenu=="002211"){ 
                         nMinutOFF++;
                         if (nMinutOFF==60) {nMinutOFF=0;}
                         delay(200);
       
       }
              else {
     posMenu = posMenu--;
     if (posMenu<0) {posMenu=0;} //не уходим в минус
     if (posMenu>0){startPos--;} //уменьшаем стартовую позицию меню
     delay(300);
       }
     lcd.clear();
   //  lcd.print("UP    ");
     break;
     }
   case btnDOWN: //Кнопка вниз
     {
       if (currentMenu=="0000") {
                         adjustTime(-60*60);
                         delay(200);
       } else if (currentMenu=="0001"){ 
                         adjustTime(-60);
                         delay(200);
       } else if ((currentMenu=="00211")||(currentMenu=="00311")||(currentMenu=="00411")||(currentMenu=="00511")){ 
                         nHumidity[nUnitNumber]=nHumidity[nUnitNumber]-10;
                         delay(200);
       }else if (currentMenu=="002200"){ 
                         nHourON--;
                         if (nHourON==-1) {nHourON=23;}
                         delay(200);
       }else if (currentMenu=="002201"){ 
                         nMinutON--;
                         if (nMinutON==-1) {nMinutON=59;}
                         delay(200);
       } else if (currentMenu=="002210"){ 
                         nHourOFF--;
                         if (nHourOFF==-1) {nHourOFF=23;}
                         delay(200);
       }else if (currentMenu=="002211"){ 
                         nMinutOFF--;
                         if (nMinutOFF==-1) {nMinutOFF=59;}
                         delay(200);
       
       }
       else {
     posMenu = posMenu++; //Выбранная позиция в меню
    
     if (posMenu>maxPunktMemu[maxkolpunkt]-1) {posMenu=maxPunktMemu[maxkolpunkt]-1;} //Не уходим ниже последнего пункта меню
          else 
          {if (posMenu>1){startPos++;}} //При нажатии на кнопку вниз увеличиваем стартовую позицию меню при прорисовке
        delay(300);
        
 //    lcd.print("DOWN  ");
     
       }
       lcd.clear();
       break;
   }
   case btnSELECT:
     {
     lcd.print("SELECT");
     break;
     }
//     case btnNONE:
//     {
//     lcd.print("NONE  ");
//     break;
//     }

 }
  
  
 }
 
 
 
void setup()
{
 lcd.begin(16, 2);              // start the library
 lcd.setCursor(0,0);
 lcd.print(""); // print a simple message
 if (isDebug) {Serial.begin(9600);}
 setTime(0,00,00,01,01,2012);
 Serial.println(freeMemory());
}
  
void loop()
{
  if (IsConfig) {SetupConfig();}
  
// lcd.setCursor(9,2);    // move cursor to second line "1" and 9 spaces over
// lcd.print(millis()/1000);      // display seconds elapsed since power-up
// 
// 
// lcd.setCursor(0,1);            // move to the begining of the second line
 lcd_key = read_LCD_buttons();  // read the buttons
 PushKey(lcd_key);
// 

// 
}
